#include "plugin.h"
#include <windows.h>

namespace utility
{

factory::handle::handle(const char* path) : f(0), data(0)
{
	data = (void*)::LoadLibrary(path);
	if (data == 0) return;
	fp_get_factory fp = (fp_get_factory)::GetProcAddress((HMODULE)data, fp_get_factory_name);
	if ((fp == 0) || ((f = fp()) == 0))
	{
		::FreeLibrary((HMODULE)data);
		data = 0;
		return;
	}
}

factory::handle::~handle()
{
	unload();
}

factory::handle& factory::handle::operator=(const handle& c)
{
	unload();
	if (c.valid())
	{
		char buffer[MAX_PATH];
		if (::GetModuleFileName((HMODULE)c.data, buffer, MAX_PATH) != 0)
		{
			data = (void*)::LoadLibrary(buffer);
			if (data != NULL) f = c.f;
		}
	}
	return *this;
}

void factory::handle::unload()
{
	if (!valid()) return;
	f = 0;
	::FreeLibrary((HMODULE)data);
	data = 0;
}

}; // namespace utility

