#include "../testbase.h"

class testplugin : public testbase
{
public:
	__PLUGIN_IMPLEMENTATION1(testplugin, testbase);
	virtual void destroy() throw()  { delete this; }
	virtual utility::plugin* clone() const throw()  { return new testplugin(*this); }
	virtual utility::plugin* instance() const throw()  { return new testplugin(); }
	virtual void print_hello() const
	{
		printf("hello world\n");
	}
};

class testfactory : public utility::factory
{
public:
	virtual size_type size() const throw()
	{
		return 1;
	}

	virtual utility::plugin* create_plugin(size_type index) const throw()
	{
		if (index == 0) return new testplugin();
		else return 0;
	}

	virtual const utility::alien_type_info* plugin_typeid(size_type index) const throw()
	{
		if (index == 0) return &alien_class_typeid(testplugin);
		else return 0;
	}
};


__PLUGIN_EXPORT const utility::factory* get_factory()
{
	static const testfactory f;
	return &f;
}
